const TblGrupoFuncionario = require("../models/TblGruposFuncionarios");

const getAllGrupoFuncionario = async (queryParams = {}) => {
  return TblGrupoFuncionario.findAll({
    where: queryParams,
  });
};

const getGrupoFuncionarioById = async (id, queryParams = {}) => {
  const whereCondition = { intId: id, ...queryParams };

  return TblGrupoFuncionario.findOne({
    where: whereCondition,
  });
};



const createGrupoFuncionario = async (grupoFuncionarioData) => {
  return TblGrupoFuncionario.create(grupoFuncionarioData);
};

const updateGrupoFuncionario = async (id, grupoFuncionarioData) => {
  const grupoFuncionario = await TblGrupoFuncionario.findByPk(id);
  if (!grupoFuncionario) {
    throw new Error("GrupoFuncionario not found");
  }
  return grupoFuncionario.update(grupoFuncionarioData);
};

const deleteGrupoFuncionario = async (id) => {
  // Assuming TblGrupoFuncionario is your Sequelize model
  const result = await TblGrupoFuncionario.update(
    { bitEliminado: true },
    { where: { intId: id } }
  );

  // The 'result' object contains information about the operation
  const affectedRows = result[0];

  if (affectedRows === 0) {
    throw new Error("GrupoFuncionario not found");
  }

  // You might want to return additional information if needed
  return { success: true, message: "GrupoFuncionario soft deleted successfully" };
};

module.exports = {
  getAllGrupoFuncionario,
  getGrupoFuncionarioById,
  createGrupoFuncionario,
  updateGrupoFuncionario,
  deleteGrupoFuncionario,
};
